<template>
    <div class="content-grid content-grid--subpage">

        <div class="loading-display">
            <div>
                <Breadcrumbs :title="messRoutes" />
                <BackLinkTitle class="m-5" :title="backLinkTitle" />
            </div>
            <el-affix :offset="15" position="top">
                <el-text v-if="saved" type="success" size="large"><el-icon><CircleCheckFilled /></el-icon> {{t("global.grilleSave")}}</el-text>
                <el-text v-else type="warning" size="large">
                    <el-icon class="is-loading"><Loading /></el-icon> {{t("global.grilleSave")}}
                </el-text>
            </el-affix>
        </div>
        <div class="warning-flex">
            <el-icon size="large" color="#606060"><WarningFilled /></el-icon>
            <el-text type="info" size="large">{{ t("global.infoGrille")}}</el-text>
        </div>
        <div class="btn-elements">
            <div class="info-grille">
                <div class="input-grilles">
                    <div>
                                
                        <el-text>Informations grille:</el-text>
                    </div>
                    <el-input size="small" v-model="grille.titre" @blur="updateGrille">
                        <template #prepend>
                            Titre:
                        </template>
                    </el-input>
                    <el-input-number size="small" controls-position="right" :min="1" :max="100" v-model="grille.ponderation" @change="updateGrille" />
                </div>
            </div>

            <div>
                <el-text type="info" style="display: block;">Total des points:</el-text>
                <el-input-number size="small" :min="0" v-model="grilleWeight" disabled :controls="false" style="width: fit-content" />
            </div>
        </div>
        <GrilleComponent :grille="grille" @delete-critere="deleteCritere" @add-critere="addCritere" @add-bareme="addBareme" @delete-bareme="deleteBareme"
                         @update-bareme-content="updateBaremeContent" @update-bareme-min-value="updateBaremeMinValue"
                         @update-bareme-max-value="updateBaremeMaxValue" @delete-comment="deleteComment" @add-comment="addComment"
                         @update-element-title="updateElementTitle" @update-element-weigth="updateElementWeigth" @add-element="addElement" @delete-element="deleteElement" @update-bareme-title="updateBaremeTitle" />
    </div>

</template>
<script lang="ts" setup>
    import {ref, computed, onMounted } from 'vue';
    import { useRoute, useRouter } from "vue-router";

    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";

    import GrilleComponent from "@/components/creation-grille/GrilleComponent.vue";

    import { CircleCheckFilled, CircleCloseFilled, InfoFilled, Loading, WarningFilled } from '@element-plus/icons-vue';
    import { ElNotification } from 'element-plus';

    import { Grille } from "@/types/entities/grille";
    import { Bareme } from '@/types/entities/creation-grille/Bareme';

    import { useGrilleService, useElementService, useBaremeService, useCritereService, useCommentaireGlobalService } from "@/inversify.config";
    import { ICreateGrilleRequest } from '@/types/requests/createGrilleRequest';


    import FormRow from "@/components/forms/FormRow.vue"
    import FormInput from "@/components/forms/FormInput.vue"
    import ProductBaseForm from "@/components/products/ProductBaseForm.vue"
    import FormSelect from '@/components/forms/FormSelect.vue';
    import Fieldset from "@/components/forms/Fieldset.vue";
    import { Status } from "@/validation"

    import {useI18n} from "vue3-i18n"
    import { Guid } from '../../types';
    import { ICreateElementRequest } from '@/types/requests/createElementRequest';
    import { IUpdateElementRequest } from '@/types/requests/updateElementRequest';
    import { ICreateBaremeRequest } from '@/types/requests/createBaremeRequest';
    import { IUpdateBaremeRequest } from '@/types/requests/updateBaremeRequest';
    import { ICreateCritereRequest } from '../../types/requests/createCritereRequest';
    import { ICreateCommentaireGlobalRequest } from '../../types/requests/createCommentaireGlobalRequest';
    import { IUpdateGrilleRequest } from '../../types/requests/updateGrilleRequest';
    

    const { t } = useI18n()
    const route = useRoute();

    const saved = ref<boolean>(true);


    const grilleService = useGrilleService();
    const grille = ref<Grille>(await grilleService.getGrille(route.params.idGrille.toString()));

    const elementService = useElementService();

    const baremeService = useBaremeService();

    const critereService = useCritereService();
    const commentService = useCommentaireGlobalService();

    const messRoutes = `Cours / Consultation des cours/ Details du cours / Details de la grille`;
    const backLinkTitle = "Modification"


    // Ponderation Grille

    const grilleWeight = computed(() => grille.value.element!.reduce((total, element) => total + element.ponderation!, 0));

    // Gestion Grille
    const updateGrille = async() =>{

        saved.value = false;
        await grilleService.UpdateGrille(grille.value as IUpdateGrilleRequest);
        grille.value = await await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }


    // Gestion Elements

    const addElement = async () => {
        saved.value = false;
        const new_element = {
            grilleId: grille.value.id!.toString(),
            titre: "Nouvel Element",
            ponderation: 5,
            critere: [],
            bareme: [],
            commentaire: []
        } as ICreateElementRequest
        await elementService.CreateElement(new_element);
        grille.value.element!.push(new_element);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }

    const deleteElement = async(elementIndex: number) => {

        saved.value = false;
        await elementService.DeleteElement(grille.value.element![elementIndex].id!);
        grille.value.element!.splice(elementIndex, 1);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }

    const updateElementTitle = async(content: string, elementIndex: number) => {

        saved.value = false;
        grille.value.element![elementIndex].titre = content
        await elementService.UpdateElement(grille.value.element![elementIndex] as IUpdateElementRequest);
        saved.value = true;
    };

    const updateElementWeigth = async(value: number, elementIndex: number) => {

        saved.value = false;
        grille.value.element![elementIndex].ponderation = value
        await elementService.UpdateElement(grille.value.element![elementIndex] as IUpdateElementRequest);
        saved.value = true;
    }

    // Gestion Baremes

    const addBareme = async(index: number) => {

        saved.value = false;
        const element = grille.value.element![index];
        let value: number;

        if(element.bareme!.length > 0 ){
            if (element.bareme![element.bareme!.length - 1].minValue != null) {
                value = element.bareme![element.bareme!.length - 1].minValue! - 1;
            } else {
                value = element.bareme![element.bareme!.length - 1].maxValue - 1;
            }
            if (value > 0){

                const new_bareme = { titre: "", description: "", maxValue: value, minValue: null, elementId: element.id?.toString() };

                element.bareme?.push(new_bareme);
                await baremeService.CreateBareme(new_bareme as ICreateBaremeRequest);

            }
            else
                ElNotification.warning({
                    title: "Ajout Bareme",
                    message: "Vous ne pouvez pas ajouter de bareme",
                    showClose: false,
                    duration: 1500,
                });

        }else{
            const new_bareme = { titre: "", description: "", maxValue: 10, minValue: null, elementId: element.id?.toString() };

            await baremeService.CreateBareme(new_bareme as ICreateBaremeRequest);
        }

        grille.value = await grilleService.getGrille(route.params.idGrille.toString()); 
        saved.value = true;
    };

    const updateBaremeContent = async(elementIndex: number, baremeIndex: number, content: string) => {

        saved.value = false;
        grille.value.element![elementIndex].bareme![baremeIndex].description = content
        await baremeService.UpdateBareme(grille.value.element![elementIndex].bareme![baremeIndex] as IUpdateBaremeRequest);
        saved.value = true;
    }

    const updateBaremeMaxValue = async(value: number, baremeIndex: number, elementIndex: number) => {

        saved.value = false;
        grille.value.element![elementIndex].bareme![baremeIndex].maxValue = value
        await baremeService.UpdateBareme(grille.value.element![elementIndex].bareme![baremeIndex] as IUpdateBaremeRequest);
        saved.value = true;
    }

    const updateBaremeMinValue = async(value: number | null, baremeIndex: number, elementIndex: number) => {

        saved.value = false;
        grille.value.element![elementIndex].bareme![baremeIndex].minValue = value
        await baremeService.UpdateBareme(grille.value.element![elementIndex].bareme![baremeIndex] as IUpdateBaremeRequest);
        saved.value = true;
    }

    const deleteBareme = async(baremeIndex: number, elementIndex: number) => {
        saved.value = false;
        await baremeService.DeleteBareme(grille.value.element![elementIndex].bareme![baremeIndex].id!.toString())
        grille.value.element![elementIndex].bareme!.splice(baremeIndex, 1);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString()); 
        saved.value = true;
    }

    const updateBaremeTitle = async(content: string, baremeIndex: number, elementIndex: number) => {

        saved.value = false;
        grille.value.element![elementIndex].bareme![baremeIndex].titre = content;
        await baremeService.UpdateBareme( grille.value.element![elementIndex].bareme![baremeIndex] as IUpdateBaremeRequest);

        saved.value = true;
    }

    // Gestion Criteres

    const addCritere = async(content: string, index: number) => {

        saved.value = false;
        const critere = { elementId :grille.value.element![index].id!, detail: content.trim() }
        await critereService.CreateCritere(critere as ICreateCritereRequest);
        grille.value.element![index].critere!.push(critere);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }

    const deleteCritere = async(critereIndex: number, elementIndex: number) => {

        saved.value = false;
        await critereService.DeleteCritere(grille.value.element![elementIndex].critere![critereIndex].id!);
        grille.value.element![elementIndex].critere!.splice(critereIndex, 1);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }

    //Gestion Commentaires

    const addComment = async(content: string, index: number) => {

        saved.value = false;
        const comment = {commentaire: content.trim(), elementId: grille.value.element![index].id}

        await commentService.CreateCommentaireGlobal(comment as ICreateCommentaireGlobalRequest)

        grille.value.element![index].commentaire!.push(comment);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }

    const deleteComment = async(commentIndex: number, elementIndex: number) => {

        saved.value = false;
        await commentService.DeleteCommentaireGlobal( grille.value.element![elementIndex].commentaire![commentIndex].id!)
        grille.value.element![elementIndex].commentaire!.splice(commentIndex, 1);
        grille.value = await grilleService.getGrille(route.params.idGrille.toString());
        saved.value = true;
    }

</script>
<style scoped>
    .warning-flex{
        display: flex;
        align-content: center;
        gap: 5px;
        margin: 0 auto;
    }
    .btn-elements {
        display: flex;
        align-items: end;
        justify-content: space-between;
        margin: 0 0 15px 0;
    }
    .dialog-header{
        display: flex;
        align-items: center;
        justify-content: space-between;
    }
    .input-grilles{
        display: flex;
        justify-content: end;
        flex-direction: column;
        align-items: start;
        gap: 5px;
    }
    .input-submit{
        margin: 0 0 10px 0;
    }
    .info-grille{
        padding: 10px;
        border: 1px solid lightgray;
        border-radius: 15px;
    }
    .tooltip-flex{
        display: flex;
        align-items:center;
        justify-content: center;
        gap:5px;
    }
    .loading-display{
        display: flex;
        align-items: start;
        justify-content: space-between;
    }
    .m-5{
        margin-top: 20px;
    }
</style>
